#pragma once

#ifndef HW_LIB_FONT_CHUC_H
#define HW_LIB_FONT_CHUC_H

typedef struct {
    uint8_t unicode[2];
    uint8_t data[32];
} Chinese_t;

static uint8_t Hzk_size = 16;

static Chinese_t Hzk[] = {
        {
                // Original: 
                {0x66, 0x1F},
                {
                        0x00, 0x08, 0x3F, 0xFC, 0x20, 0x08, 0x3F, 0xF8, 0x20, 0x08, 0x3F, 0xF8, 0x01, 0x00, 0x21, 0x08,
                        0x3F, 0xFC, 0x21, 0x00, 0x41, 0x10, 0xBF, 0xF8, 0x01, 0x00, 0x01, 0x04, 0xFF, 0xFE, 0x00, 0x00,
                }
        },
        {
                // Original: 
                {0x6D, 0x77},
                {
                        0x02, 0x00, 0x42, 0x08, 0x33, 0xFC, 0x14, 0x00, 0x8B, 0xF8, 0x62, 0x88, 0x22, 0x48, 0x0A, 0x08,
                        0x1F, 0xFE, 0x24, 0x88, 0xE4, 0x48, 0x24, 0x08, 0x27, 0xFC, 0x20, 0x08, 0x20, 0x28, 0x20, 0x10,
                }
        },
        {
                // Original: 
                {0x79, 0xD1},
                {
                        0x04, 0x10, 0x0E, 0x10, 0xF8, 0x90, 0x08, 0x50, 0x08, 0x10, 0xFE, 0x90, 0x08, 0x50, 0x1C, 0x14,
                        0x1A, 0x1E, 0x29, 0xF0, 0x28, 0x10, 0x48, 0x10, 0x88, 0x10, 0x08, 0x10, 0x08, 0x10, 0x08, 0x10,
                }
        },
        {
                // Original: 
                {0x62, 0x80},
                {
                        0x10, 0x40, 0x10, 0x40, 0x10, 0x48, 0x13, 0xFC, 0xFC, 0x40, 0x10, 0x40, 0x10, 0x40, 0x13, 0xF8,
                        0x1A, 0x08, 0x31, 0x10, 0xD1, 0x10, 0x10, 0xA0, 0x10, 0x40, 0x10, 0xB0, 0x51, 0x0E, 0x26, 0x04,
                }
        },
        {
                // Original: 
                {0x67, 0x3A},
                {
                        0x10, 0x00, 0x10, 0x10, 0x11, 0xF8, 0x11, 0x10, 0xFD, 0x10, 0x11, 0x10, 0x31, 0x10, 0x39, 0x10,
                        0x55, 0x10, 0x51, 0x10, 0x91, 0x10, 0x11, 0x10, 0x11, 0x12, 0x12, 0x12, 0x14, 0x0E, 0x18, 0x00,
                }
        },
        {
                // Original: е
                {0x68, 0xB0},
                {
                        0x10, 0x20, 0x10, 0x28, 0x10, 0x24, 0x17, 0xFE, 0xFC, 0x20, 0x12, 0xA0, 0x32, 0xA0, 0x3A, 0xA4,
                        0x57, 0xE4, 0x52, 0xA8, 0x92, 0xA8, 0x12, 0x90, 0x14, 0xB0, 0x18, 0x52, 0x10, 0x8A, 0x13, 0x06,
                }
        },
        {
                // Original: ʦ
                {0x5E, 0x08},
                {
                        0x08, 0x04, 0x0B, 0xFE, 0x48, 0x20, 0x48, 0x24, 0x49, 0xFE, 0x49, 0x24, 0x49, 0x24, 0x49, 0x24,
                        0x49, 0x24, 0x49, 0x24, 0x49, 0x24, 0x49, 0x24, 0x11, 0x34, 0x11, 0x28, 0x20, 0x20, 0x40, 0x20,
                }
        },
};

static Chinese_t *find_chinese_data(uint8_t unicode_high, uint8_t unicode_low) {
    for (int i = 0; i < sizeof(Hzk) / sizeof(Chinese_t); ++i) {
        if (Hzk[i].unicode[0] == unicode_high && Hzk[i].unicode[1] == unicode_low) {
            return &Hzk[i];
        }
    }
    return NULL;
}

#endif //HW_LIB_FONT_CHUC_H
